function [L,R,P] = myLUCols(A)

n = size(A,1);
p=1:n;

for k=1:n-1
  %*** bestimme maximalen Wert in k-ter Spalte
  [~,mptr] = max(abs(A(p(k:end),k)));

  %*** tausche Zeilen
  tmp = p(k);
  p(k) = p(k-1+mptr);
  p(k-1+mptr) = tmp;
  %*** fhre LR-Schritt aus
  for j = k+1 : n
    A(p(j),k) = A(p(j),k)/A(p(k),k);
    for i = k+1 : n
      A(p(j),i) = A(p(j),i) - A(p(j),k)*A(p(k),i);
    end
  end
end
%*** extrahieren die Matrizen L,R und P
L = tril(A(p,:),-1)+eye(n);
R = triu(A(p,:));
P=eye(n);
P(:,p) = P;