clc,clear all, close all

%*** Definiere A, b, x
A = [      9,      3-3i,      -6-9i,     -4.5+6i,        6-3i;...
         3+3i,        6,      13-4i,    0.5-8.5i,        1-5i;...
        -6+9i,    13+4i,       55.5,   26.75-34i,  -17.25-12i;...
      -4.5-6i, 0.5+8.5i,  26.75+34i,        96.5, -22.5-18.5i;...
        6+3i ,     1+5i, -17.25+12i, -22.5+18.5i,       78.25];
x = [3+1i;2+2i;-1-3i;2+5i;3-1i];
b = [1+2i;2+8i;-1-1i;1-3i;3-2i];
  
%*** konvertiere in reelles Format
A2 = imag(tril(A,-1))'+real(tril(A,-1))+diag(diag(A));


%*** Matrix-Vektor-Multiplikation
y = myMatVec(A2,[real(x),imag(x)]);
% Ueberpruefe Ergebnis
if max(abs(complex(y(:,1),y(:,2))-A*x))<1e-10
  disp('myMatVec..... ok!')
end

%*** LGS loesen
x = mySolve(A2,[real(b),imag(b)]);
x2 = A\b;
% Ueberpruefe Ergebnis
if max(abs(complex(x(:,1),x(:,2))-x2))<1e-10
  disp('mySolve..... ok!')
end

%*** berechne Cholesky-Zerlegung mit reellem Algorithmus 
L = myCholesky(A2);
%*** konvertiere ins Standard-Format
LL = diag(diag(L))+1i*triu(L,1)'+tril(L,-1);

%*** Ueberpruefe Ergebnis
if max(max(abs(A-LL*LL')))<1e-10
  disp('Cholesky..... ok!')
end




